import os
import sys

print (" -------------------------------------------")
print (" -      Tekisasu-Engine build script       -")
print (" -------------------------------------------")
print (" ")

def tekisasu_input(action):
#	print ("The choice was: ", action)
	if action == "build":
		print ("\n\n * STARTING BUILD!\n\n")
		tekisasu_build()
	elif action == "clean":
		print ("\n\n * STARTING CLEAN!\n\n")
		tekisasu_clean()
	else:
		print ("Error: use arguments 'build' or clean'.")

def tekisasu_clean():
	os.system("scons platform=windows -j8 tools=yes target=release_debug bits=64 -c")
	os.system("scons platform=windows -j8 tools=no target=release_debug bits=32 -c")
	os.system("scons platform=windows -j8 tools=no target=release bits=32 -c")
	os.system("scons platform=windows -j8 tools=no target=release_debug bits=64 -c")
	os.system("scons platform=windows -j8 tools=no target=release bits=64 -c")
	print ("\n\n * CLEAN COMPLETE!\n\n")

def tekisasu_build():
	# build Tools & debug export templates
	os.system("scons platform=windows -j8 tools=yes target=release_debug bits=64")
	os.system("scons platform=windows -j8 tools=no target=release_debug bits=32")
	os.system("scons platform=windows -j8 tools=no target=release_debug bits=64")
	# copy temp custom build defs for RELEASE export templates
	os.system("echo F | xcopy .tekisasu-custom.py custom.py")
	# build release export templates
	os.system("scons platform=windows -j8 tools=no target=release bits=32 use_lto=yes")
	os.system("scons platform=windows -j8 tools=no target=release bits=64 use_lto=yes")
	# remove temp custom build defs
	os.system("del custom.py")
	# Tekisasu-Engine.exe
	if os.path.exists("bin/godot.windows.opt.tools.64.exe"):
		os.system("echo F | xcopy bin\godot.windows.opt.tools.64.exe bin\Tekisasu-Engine.exe")
	# windows_64_debug.exe
	if os.path.exists("bin/godot.windows.opt.debug.64.exe"):
		os.system("echo F | xcopy bin\godot.windows.opt.debug.64.exe bin\windows_64_debug.exe")
	# windows_32_debug.exe
	if os.path.exists("bin/godot.windows.opt.debug.32.exe"):
		os.system("echo F | xcopy bin\godot.windows.opt.debug.32.exe bin\windows_32_debug.exe")
	# windows_64_release.exe
	if os.path.exists("bin/godot.windows.opt.64.exe"):
		os.system("echo F | xcopy bin\godot.windows.opt.64.exe bin\windows_64_release.exe")
	# windows_32_release.exe
	if os.path.exists("bin/godot.windows.opt.32.exe"):
		os.system("echo F | xcopy bin\godot.windows.opt.32.exe bin\windows_32_release.exe")
	print ("\n\n * BUILD COMPLETE!\n\n")

action = sys.argv[1]
tekisasu_input(action)